# -*- coding: utf-8 -*-
# Project : flacon
# File : about.py
# (c) Alexander Sokolov asokol@mail.ru
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.




#import preferences
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

import pyqticonloader
import flacon
from aboutDialog_ui import *
#from flaconglobal import *


class AboutDialog(QtGui.QDialog, Ui_aboutDialog):
   #****************************************************************
   #
   #****************************************************************
    def __init__(self):
        QDialog.__init__(self)
        self.setupUi(self)

        # Strings ::::::::::::::::::::::::::::::::::::::::::::::::::
        windowTitle = self.tr("About Flacon")
        description = self.tr("Extracts individual tracks from one big audio file containing the entire album.",)
        version     = self.tr("Version: %1").arg(flacon.FLACON_VERSION)
        webSiteStr  = self.tr("Web site:")
        licenseStr  = self.tr("License:")


        authors     = [
                ("Alexander Sokolov",
                    "asokol@mail.ru",
                    ''
                )
            ]


        helpers     = [
                ('Artem Aleksuk',
                    'mailto:h31mail@yandex.ru',
                    'WavePack support patch.'
                ),

                ('Charles Barcza',
                    'mailto:kbarcza@blackpanther.hu',
                    'Application icon, Packaging.'
                ),

                ('Kyrill Detinov',
                    'mailto:lazy.kent@opensuse.org',
                    'Packaging, testing.'
                ),

                ('Pavel Fric',
                    'http://fripohled.blogspot.com',
                    'Czech translation.'
                ),
            ]

        copyright  = "&copy; Alexander Sokolov, 2009-2010"
        license    = "<a href=http://www.fsf.org/licensing/licenses/gpl.html>GNU General Public License Version 3</a>"
        siteUrl    = "http://kde-apps.org/content/show.php/Flacon?content=113388"

        # :::::::::::::::::::::::::::::::::::::::::::::::::::::::::

        css = QString('''<style type="text/css">
                            .name { font-weight: bold;  font-size: 12pt; }
                            .ver  { font-weight: bold;  qfont-size: 8pt; }
                            a     { white-space: nowrap ; }
                        </style>''')


        self.setWindowTitle(windowTitle)

        logo = pyqticonloader.icon('flacon', [48]).pixmap(48, 48)
        self.logoLabel.setPixmap(logo)


        self.titleLabel.setText(css + ("<div class=name>Flacon</div><div class=ver>%s</div><p>" % version))


        aboutText = "%s<p>" % description   + \
                    "<br>%s"    % copyright     + \
                    "<hr>"                  + \
                    "%s <a href='%s'>%s</a><br>" % (webSiteStr, siteUrl, siteUrl) + \
                    "%s %s" % (licenseStr, license)
        self.aboutLabel.setText(css+aboutText)


        self.authorsEdit.viewport().setAutoFillBackground(False)
        self.authorsEdit.setText(css + self._getListString(authors))


        self.thanksEdit.viewport().setAutoFillBackground(False)
        self.thanksEdit.setHtml(css + self._getListString(helpers))



   #****************************************************************
   #
   #****************************************************************
    def _getListString(self, list):
        result = ''
        for (name, url, role) in list:
            result += "<b>%s</b>" % name

            if url:
                text = QString(url).remove('mailto:')
                result +="<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href='mailto:%s'>%s</a>" % (url, text)

            if role:
                result +="<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%s" % role

            result += "<p>"

        return result


